/**
 * Class containing core telemetry functions
 */
export declare class PerformanceTelemetryService {
    /**
     * Starts capture cycle period
     */
    static startCaptureCycle(): void;
    /**
     * Captures timings for the given period
     * @param isRedirect Bool dictating whether timings were captured at end of cycle or early
     */
    static captureTimings(isRedirect?: boolean): void;
    /**
     * Creates timings object to send to telemetry
     * @param isRedirect isRedirect bool
     */
    static submitTelemetry(isRedirect: boolean): void;
    /**
     * Adds remaining metadata to send to logger and dispatches event
     * @param timings
     */
    static log(timings: any): void;
    /**
     * Checks whether window.performance is undefined
     */
    static compatibilityCheck(): boolean;
}
